/*******************************************************************************
 * Copyright (c) 2015-2016 ONERA.
 * Ce logiciel est la propriété de l’ONERA (the French Aerospace Lab).
 * Tous droits réservés.
 *
 * Ce programme et les éléments qui l'accompagnent sont mis à disposition
 * aux conditions définies par le contrat de licence logiciel CeCILL-C soumise
 * au droit français et respectant les principes de diffusion des logiciels libres.
 * Vous pouvez utiliser, modifier et/ou redistribuer ce programme
 * sous les conditions de la licence CeCILL-C (http://www.cecill.info).

 * This software is property of ONERA (the French Aerospace Lab).
 * All rights reserved.
 *
 * This program and the accompanying materials are made available under
 * the terms of the CeCILL-C license under French law and
 * abiding by the rules of distribution of free software.
 * You can  use, modify and/ or redistribute the software under the terms of
 * the CeCILL-C license (http://www.cecill.info).
 *
 * Contributeurs/contributors:
 *     Guillaume Infantes (ONERA - Centre de Toulouse) - initial API and implementation
 *
 *******************************************************************************/

#ifndef ALTARICA_INIT_INFO_HH
#define ALTARICA_INIT_INFO_HH

#include <string>
#include <map>
#include <vector>

namespace epoch {
  namespace altarica {

    class Value;
    class AltaricaModel;
    class EventLaw;
    class Event;
    class Variable;
    class Node;



    class AltaricaInitInfo {
    protected:
      std::map<unsigned int, Value*> initValues;
      std::map<Event *, EventLaw *> initLaws;
      AltaricaModel * amodel;
      Value * getValue(Variable *var, std::string valName);

    public:
      AltaricaInitInfo(AltaricaModel *am) : amodel(am) {}
      Value * getInitValue(unsigned int i) const;
      virtual std::string toString() const;
      void overrideLaws();
      std::vector<Node*> * getNodes(std::string);

      virtual bool hasInit() {return true;}
      virtual bool hasGoal() {return false;}
      virtual bool hasEvents() {return false;}
    };
  }
}

#endif
