/*******************************************************************************
 * Copyright (c) 2015-2016 ONERA.
 * Ce logiciel est la propriété de l’ONERA (the French Aerospace Lab).
 * Tous droits réservés.
 *
 * Ce programme et les éléments qui l'accompagnent sont mis à disposition
 * aux conditions définies par le contrat de licence logiciel CeCILL-C soumise
 * au droit français et respectant les principes de diffusion des logiciels libres.
 * Vous pouvez utiliser, modifier et/ou redistribuer ce programme
 * sous les conditions de la licence CeCILL-C (http://www.cecill.info).

 * This software is property of ONERA (the French Aerospace Lab).
 * All rights reserved.
 *
 * This program and the accompanying materials are made available under
 * the terms of the CeCILL-C license under French law and
 * abiding by the rules of distribution of free software.
 * You can  use, modify and/ or redistribute the software under the terms of
 * the CeCILL-C license (http://www.cecill.info).
 *
 * Contributeurs/contributors:
 *     Guillaume Infantes (ONERA - Centre de Toulouse) - initial API and implementation
 *
 *******************************************************************************/

#ifndef ALTA_ASSIGNMENT_H_
#define ALTA_ASSIGNMENT_H_

#include "MemberAccess.hh"

namespace epoch {
    namespace altarica {

	class Node;
	class Variable;
	class Expression;
	class Value;
	class AltaricaState;
	class AltaricaModel;
	
	class Assignment {
	protected : 
	    //! liste des membres a affecter
	    MemberAccess* ma_;

	    //! affectation à donner au membre correspondant
	    Expression* e_;
	    // Expression* oe_;

	    Node * n_;

	    Variable * v_;

	public :
	    Assignment(MemberAccess* m, Expression*e):ma_(m),e_(e),n_(NULL),v_(NULL) {
		//		oe_ = e_->toOpenExpr();
	    }
	    ~Assignment();

	    Assignment * clone() const {return new Assignment(ma_->clone(), e_);}

	    void setNode(Node*n);
	    Node * getNode() {return n_;}

	    //	    void matchVariable(bool init);

	    const Variable* getVar() const {return v_;}
	    const Expression * getExpr() const {return e_;}

	    Value * evaluate(const AltaricaModel *am, AltaricaState *m, const Node *n) const;
	    Value * evaluate(const AltaricaModel *am, AltaricaState *m) const;


	    void deleteExprs();

	    const MemberAccess * getMA() {return ma_;}

	};
    }
}

#endif
