/*******************************************************************************
 * Copyright (c) 2015-2016 ONERA.
 * Ce logiciel est la propriété de l’ONERA (the French Aerospace Lab).
 * Tous droits réservés.
 *
 * Ce programme et les éléments qui l'accompagnent sont mis à disposition
 * aux conditions définies par le contrat de licence logiciel CeCILL-C soumise
 * au droit français et respectant les principes de diffusion des logiciels libres.
 * Vous pouvez utiliser, modifier et/ou redistribuer ce programme
 * sous les conditions de la licence CeCILL-C (http://www.cecill.info).

 * This software is property of ONERA (the French Aerospace Lab).
 * All rights reserved.
 *
 * This program and the accompanying materials are made available under
 * the terms of the CeCILL-C license under French law and
 * abiding by the rules of distribution of free software.
 * You can  use, modify and/ or redistribute the software under the terms of
 * the CeCILL-C license (http://www.cecill.info).
 *
 * Contributeurs/contributors:
 *     Guillaume Infantes (ONERA - Centre de Toulouse) - initial API and implementation
 *
 *******************************************************************************/

#ifndef ALTA_CONSTANT_H_
#define ALTA_CONSTANT_H_

#include <string>
#include <vector>

namespace epoch {
  namespace altarica {

    class Domain;
    class Expression;
    class Value;
    class AltaricaState;
    class AltaricaModel;
    class Node;

    class Constant {

    protected:

      //!
      std::string name_;
      Domain * domain_;
      Expression * expr_;



    public:

      //!
      Constant(std::string name);

      Constant(std::string name, Domain* d);

      Constant(std::string name, Domain* d, Expression *expr);
      ~Constant();

      const Domain* getDomain() const;
      const Expression* getExpression() const;
      void setExpression(Expression *expr);

      Value * getValue(const AltaricaModel *am,
                       AltaricaState *s,
                       const Node* n) const;

      static Constant* findConstantInVector(std::vector<Constant*>v,
                                            std::string *constName);

      std::string  getName() {return name_;}
    };
  }
}

#endif
