/*******************************************************************************
 * Copyright (c) 2015-2016 ONERA.
 * Ce logiciel est la propriété de l’ONERA (the French Aerospace Lab).
 * Tous droits réservés.
 *
 * Ce programme et les éléments qui l'accompagnent sont mis à disposition
 * aux conditions définies par le contrat de licence logiciel CeCILL-C soumise
 * au droit français et respectant les principes de diffusion des logiciels libres.
 * Vous pouvez utiliser, modifier et/ou redistribuer ce programme
 * sous les conditions de la licence CeCILL-C (http://www.cecill.info).

 * This software is property of ONERA (the French Aerospace Lab).
 * All rights reserved.
 *
 * This program and the accompanying materials are made available under
 * the terms of the CeCILL-C license under French law and
 * abiding by the rules of distribution of free software.
 * You can  use, modify and/ or redistribute the software under the terms of
 * the CeCILL-C license (http://www.cecill.info).
 *
 * Contributeurs/contributors:
 *     Guillaume Infantes (ONERA - Centre de Toulouse) - initial API and implementation
 *
 *******************************************************************************/

#ifndef LANDMARK_METAEVENT_HH
#define LANDMARK_METAEVENT_HH


#include <string>


namespace epoch {
    namespace altarica {
	
	class AltaricaModel;
	class MetaEvent;
	class LandmarkState;
	class AltaricaState;

	class LandmarkMetaEvent {

	private:
	    MetaEvent *me_;
	    AltaricaModel *am_;
	    AltaricaState *label_;

	public:
	    LandmarkMetaEvent(MetaEvent *me, AltaricaModel *m);
	    const MetaEvent * getMetaEvent() const {return me_;}

	    void addLabel(const AltaricaState * l);
	    
	    const AltaricaState* getLabel() const {return label_;}

	    
	    std::string toString() const;

	    void computeLabels(const AltaricaModel*am, const LandmarkState *als);

	};
    }
}

#endif
