/*******************************************************************************
 * Copyright (c) 2015-2016 ONERA.
 * Ce logiciel est la propriété de l’ONERA (the French Aerospace Lab).
 * Tous droits réservés.
 *
 * Ce programme et les éléments qui l'accompagnent sont mis à disposition
 * aux conditions définies par le contrat de licence logiciel CeCILL-C soumise
 * au droit français et respectant les principes de diffusion des logiciels libres.
 * Vous pouvez utiliser, modifier et/ou redistribuer ce programme
 * sous les conditions de la licence CeCILL-C (http://www.cecill.info).

 * This software is property of ONERA (the French Aerospace Lab).
 * All rights reserved.
 *
 * This program and the accompanying materials are made available under
 * the terms of the CeCILL-C license under French law and
 * abiding by the rules of distribution of free software.
 * You can  use, modify and/ or redistribute the software under the terms of
 * the CeCILL-C license (http://www.cecill.info).
 *
 * Contributeurs/contributors:
 *     Guillaume Infantes (ONERA - Centre de Toulouse) - initial API and implementation
 *
 *******************************************************************************/

// This file is part of EPOCH.
// File: EvaluationVisitor.hh
// Author: Xavier Pucel
// Contact: xavier.pucel@onera.fr
//
//    EPOCH is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    EPOCH is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with EPOCH.  If not, see <http://www.gnu.org/licenses/>.

#ifndef EVALUATION_VISITOR_HH
#define EVALUATION_VISITOR_HH

#include "Visitor.hh"

namespace epoch {

  namespace altarica {

    class AltaricaState;
    class Node;
    class AltaricaModel;

    class EvaluationVisitor: public Visitor {
    protected:
	    AltaricaState *state_;
	    const AltaricaModel *amodel_;
	    const Node *node_;

      EvaluationVisitor(const AltaricaModel *am, AltaricaState *s, const Node *n):
        state_(s), amodel_(am), node_(n) {}
    };
  }

}

#endif
