/*******************************************************************************
 * Copyright (c) 2015-2017 ONERA and IRT AESE (IRT Saint Exupéry).
 * Ce logiciel est la propriété de l’ONERA (the French Aerospace Lab) et de
 * l'IRT AESE (IRT Saint Exupéry).
 * Tous droits réservés.
 *
 * Ce programme et les éléments qui l'accompagnent sont mis à disposition
 * aux conditions définies par le contrat de licence logiciel CeCILL-C soumise
 * au droit français et respectant les principes de diffusion des logiciels libres.
 * Vous pouvez utiliser, modifier et/ou redistribuer ce programme
 * sous les conditions de la licence CeCILL-C (http://www.cecill.info).

 * This software is property of ONERA (the French Aerospace Lab) and of
 * the IRT AESE (IRT Saint Exupéry).
 * All rights reserved.
 *
 * This program and the accompanying materials are made available under
 * the terms of the CeCILL-C license under French law and
 * abiding by the rules of distribution of free software.
 * You can  use, modify and/ or redistribute the software under the terms of
 * the CeCILL-C license (http://www.cecill.info).
 *
 * Contributeurs/contributors:
 *     Guillaume Infantes (ONERA - Centre de Toulouse) - initial API and implementation
 *     Alexandre Albore (IRT Saint-Exupéry) - Altarica/Fiacre translation
 *
 *******************************************************************************/

#ifndef ALTA_EXPRESSION_CASE_H_
#define ALTA_EXPRESSION_CASE_H_


#include "Expression.hh"



namespace epoch {
    namespace altarica {


	class ExpressionCASE : public Expression {
	
	private:
	    
	    std::vector<Expression*> cond_;
	    std::vector<Expression*> then_;
	    Expression * else_;

	    
	public:
 	    ExpressionCASE(): cond_(), then_(), else_(NULL) {}
 	    virtual ~ExpressionCASE();

	    void addCase(Expression * c, Expression* t);
	    void addElse(Expression * t);

	    const std::vector<Expression*> * getConds() const {return &cond_;}
	    const std::vector<Expression*> * getThens() const {return &then_;}
	    const Expression*  getElse() const {return else_;}

	    virtual ExpressionCASE * clone() const ;

	    virtual void accept(Visitor* v) const {v->visitCASE(this);}
	    virtual std::string toString() const ;
	    virtual std::string toString(const Node *n, const AltaricaModel& am) const ;
	    virtual std::string toString(const Node *n, const std::pair<std::string,std::string> *f, const AltaricaModel& am) const ;
	    virtual std::string toFiacre(const Node *n, const std::pair<std::string,std::string> *f, const AltaricaModel& am, std::string h) const ;

	};
    }
}


#endif
